<!DOCTYPE html>
<html>
<head>
	<title>Customer App</title>
	 <meta name="viewport" content="width=device-width, initial-
         scale=1.0" />
</head>
<body style="margin:2%;">
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous">
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.bundle.min.js" integrity="sha384-ygbV9kiqUc6oa4msXn9868pTtWMgiQaeYH7/t7LECLbyPA2x65Kgf80OJFdroafW" crossorigin="anonymous">
	</script>

	<h3>Customer App</h3>
	<div class="col-sm-6">
		<button class="btn btn-link" onclick="location='./customers.html'">Customers</button> | 
		<button class="btn btn-link" onclick="location='./products.html'">Products</button> | 
		<button class="btn btn-link" onclick="location='./about.html'">About</button> |
		<button class="btn btn-link" onclick="location='/'" >Logout</button>
		<hr/>
	</div>
	 <button onclick="location='./add-customer.html'" class="btn btn-primary" >Add</button> <br/>

		Sort By: <button class="btn btn-secondary" onclick="sortCustomer('id')">Id</button> |
		 <button class="btn btn-secondary" onclick="sortCustomer('name')">Name</button> | 
		 <button class="btn btn-secondary" onclick="sortCustomer('email')">Email</button> | 
		 <button class="btn btn-secondary" onclick="sortCustomer('phone')">Phone</button> | 
		 <button class="btn btn-secondary" onclick="sortCustomer('address')">Address</button>
		<br/><br/>

		<input id="searchText" placeholder="Search text" name="">
		<label>Search By</label>
		<select name="field" id="field">
		  <option value="name">Name</option>
		  <option value="email">Email</option>
		  <option value="phone">Phone</option>
		  <option value="address">Address</option>
		  <option value="id">Id</option>
		</select>
		<button  class="btn btn-primary" onclick="doSearch()">Search</button> <br/><br/>

		<table class="table table-striped">
				<thead>
					<tr>
						<th>#</th>
						<th>Name</th>
						<th>Email</th>
						<th>Phone</th>
						<th>Address</th>
						<th></th>
						<th></th>
					</tr>
				</thead>
			<tbody id="result">
			</tbody>
		</table><br/><br/>

	
	<script type="text/javascript">
		var customers = [];
		var doSearch = async () =>{
			var field = document.getElementById('field').value;
			var searchText = document.getElementById('searchText').value.toLowerCase();
			console.log("searchText.."+searchText);
			console.log("field::"+field);
			console.log("searchText::"+searchText);
			var searchCustomer = [];
			await fetch('/api/customer/'+field+"/"+searchText, {
			  method: 'GET', // or 'PUT'
			  headers: {
			    'Content-Type': 'application/json',
			  }
			})
			.then(response => response.json())
			.then((data) => {
				searchCustomer = data;
			})
			.catch((error) => {
			  console.error('Error:', error);
			});

			displayCustomers(searchCustomer);
			//implement Search // max time 20 mins
		}

		var selectedId = 0; // 0 means new record

		var sortCustomer = (sortField) =>{
			customers = customers.sort((a,b)=>{
				console.log('a:'+ JSON.stringify(a));
				console.log('b:'+ JSON.stringify(b));
				//if(a.name > b.name){
			    if(a[sortField] > b[sortField]){
			        return 1;
			    }else{
			        return -1;
			    }
			});
			displayCustomers(customers);
			//updateStorage();
		}

		updateStorage = () =>{
			localStorage.setItem("customers", JSON.stringify(customers));
		}
		resetForm = function() {
			document.getElementById('name').value="";
			document.getElementById('email').value="";
			document.getElementById('phone').value="";
			document.getElementById('address').value="";
			document.getElementById('addButton').value="Add";
			selectedId = 0; //this indicate new Record
		}
		updateCustomer =function(id){
			location = "add-customer.html?id="+id;
			/*
			//var temp = customers.filter((item) => (item.id == id));
			//var temp = customers.filter((item) => {return item.id == id;});
			var temp = customers.filter(function(item){return item.id == id;});
			if(temp.length > 0 ){
				let record = temp[0];
				selectedId = record.id; //selected record Id
				document.getElementById('name').value=record.name;
				document.getElementById('email').value=record.email;
				document.getElementById('phone').value=record.phone;
				document.getElementById('address').value=record.address;
				document.getElementById('addButton').value="Update";
			}
			*/
		}
		addOrUpdateCustomer = function(){
			var name = document.getElementById('name').value;
			var email = document.getElementById('email').value;
			var phone = document.getElementById('phone').value;
			var address = document.getElementById('address').value;

			if(selectedId == 0){ //means new record to add
				var len = customers.length;
				if(len > 0){
					let lastId = customers[len - 1].id
					var id =lastId +1
				}else{
					var id = 1;
				}
				customers.push({id,name,email,phone,address});
			}else{ // record to update
				var id = selectedId; //selected record Id
				var array = customers.filter((item) => (item.id == id));
				array[0].name = name;
				array[0].email = email;
				array[0].address = address;
				array[0].phone = phone;
			}	
			updateStorage();
			displayCustomers(customers);
			resetForm();
		}
	
		deleteCustomer = async function(id){
			await fetch('/api/customer', {
			  method: 'DELETE', // or 'PUT'
			  headers: {
			    'Content-Type': 'application/json',
			  },
			  body: JSON.stringify({id:id}),
			})
			.then(response => response.json())
			.then((data) => {
				doFetchServer();
			})
			.catch((error) => {
			  console.error('Error:', error);
			});			
		}
		displayCustomers = function(customers){
			//JSON.stringify(s);
			console.log(customers.length);
			const list = document.getElementById("result"); //result is the list
			list.innerHTML = "";
			for (var i=0; i < customers.length; i++  ) {
				let id = customers[i].id;
				const newRecord = document.createElement("tr");
				
				const newId = document.createElement("td");
				newId.innerHTML = customers[i].id;

				const newName = document.createElement("td");
				newName.innerHTML = customers[i].name;

				const newEmail = document.createElement("td");
				newEmail.innerHTML = customers[i].email;

				const newPhone = document.createElement("td");
				newPhone.innerHTML = customers[i].phone;

				const newAddress = document.createElement("td");
				newAddress.innerHTML = customers[i].address;

				newRecord.appendChild(newId);
				newRecord.appendChild(newName);
				newRecord.appendChild(newEmail);
				newRecord.appendChild(newPhone);
				newRecord.appendChild(newAddress);

				const newDeleteButton = document.createElement("td");
			  	
			  	const newButton = document.createElement("BUTTON");
			  	newButton.innerHTML = 'delete'; 
			  	newButton.setAttribute("class", "btn btn-danger");
			  	
			  	 newButton.addEventListener("click",  function(e) {


			  	//newButton.onclick = function(e){
			  		//avoid default behaviour to post form data
			  		e.preventDefault();
			  		console.log('delete :'+id);
			  		deleteCustomer(id);
			  		
				});

				newDeleteButton.appendChild(newButton);

				const newEditButton = document.createElement("td");
			  	const newEButton = document.createElement("BUTTON");
			  	newEButton.innerHTML = 'edit'; 
			  	newEButton.setAttribute("class", "btn btn-info"); 
			  	newEButton.onclick = function(e){
			  		//avoid default behaviour to post form data
			  		e.preventDefault();
			  		console.log('edit :'+id);
			  		updateCustomer(id);
			  		
				}
				newEditButton.appendChild(newEButton);
				newRecord.appendChild(newEditButton);
				newRecord.appendChild(newDeleteButton);
			  	
			  	list.appendChild(newRecord);
			}
		}
		doFetchServer = async () =>{
			console.log(">> doFetchServer 01");
			//http://localhost:3000//api/login
			await fetch('/api/customer', {
			  method: 'GET', // or 'PUT'
			  headers: {
			    'Content-Type': 'application/json',
			  },
			 // body: JSON.stringify({email,password}),
			})
			.then(response => response.json())
			.then((data) => {
				console.log(">> doFetchServer 02");
				customers = data;
				displayCustomers(customers);
			})
			.catch((error) => {
			  console.error('Error:', error);
			});
			console.log(">> doFetchServer 03");
		}
		doFetchServer();
		
	</script>
	<script type="module" src="main.js"></script>
</body>
</html>
